# Contributing to TarsGo

## 0 All pull request must go to dev branch, not master.
All pull request must use dev branch as base branch, not master , master is used for publishing.

## 1 Create an issue 
Use English as u can.
  
if you want to report a bug, use this template in issue:
```
**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Steps to reproduce the behavior:
 
** Version info 
Which go version :
Which tars version (git commit id or branch name):
Which  os:

**Expected behavior**
A clear and concise description of what you expected to happen.

**Additional context**
Add any other context about the problem here.
```
 if you want to propose a feature ,use this template in issue :
```
**Is your feature request related to a problem? Please describe.**
A clear and concise description of what the problem is. Ex. I'm always frustrated when [...]

**Describe the solution you'd like**
A clear and concise description of what you want to happen.

**Describe alternatives you've considered**
A clear and concise description of any alternative solutions or features you've considered.

**Additional context**
Add any other context or screenshots about the feature request here.

```

## 2 fork the project
click the fork button on the right top of the project.
![fork button](docs/images/fork_button.png)

## 3 create a pull request
if you want to create a pull request, you must create a issue first. 
In the pr, you should give the related issue.  
All pull request must go to dev branch, not master.

## 4 code standards
ALL go file must be formated by gofmt and  must be fixed after golint.


## 5 AUTHORS
After your pr is merged, your name and github email will be showed in AUTHORS like following.
```
# This file lists all individuals having contributed content to the repository.
# For how it is generated, see `hack/generate-authors.sh`.

ChenMingjie <15210875043@sina.cn>
sandyskies <chenmingjie0828@163.com>
Tim Xu <xiaoxubeii@gmail.com>
titustian <titustian@tencent.com>

```
